$Id: NEWS,v 1.94 2004/02/07 22:54:59 slide_o_mix Exp $


Kahakai 0.6.1 -> ...
- Vertical-only/horizontal-only maximization no longer gets
  reset to full maximization on work area changes            (PrinceOfChaos)

- hsetroot can now be given a screen mask to operate on            (hyriand)

- Window position hints are updated after a non-opaque move        (hyriand)

- Fix segfaults with pixmap themes                                 (hyriand)

- Make Imlib2 warnings go away                                     (hyriand)

- Fixed X error when displaying an empty menu                      (hyriand)

- Rounded corners on menus (same style option as windows)          (hyriand)

- Themes with no titlebar, no handlebar and/or no left/right edge are now
  possible                                                         (hyriand)

- Skip taskbar flag handling fixed                           (PrinceOfChaos)

- Desktop menu now shows the correct desktop names, which are defined in config file							    (glass-eye)

Kahakai 0.6 -> 0.6.1
- hsetroot no longer segfaults when it can't connect to a display   (hyriand)

- Long window titles no longer overwrite buttons                  (glass-eye)

- Switching viewports with a menu open no longer segfaults    (PrinceOfChaos)

- Smart window placement works correctly again                (PrinceOfChaos)

- In menu file, quotes like {zenity --info --text="Hello World"} now work
  correctly                                                   (PrinceOfChaos)

- Shaped windows work much better now (were broken since 0.5) (PrinceOfChaos)
  Dynamically changing skins in XMMS will work fine now.  

- You can now use script actions from the menu (which means you can have
  menu call back into Python/Ruby/whatever code)              (PrinceOfChaos)
  
  The new shared name -> action registry also means you can share different
  languages' actions (no way to load multiple configuration files without
  using multiple screens though)

- Window icons support, currently only used in the            (PrinceOfChaos)  
  task switcher (alt-tab)

- Fixed problems with titlebar-less windows like XMMS locking (PrinceOfChaos)
  up

Kahakai 0.5.1 -> 0.6
- Menu outline now appears as 1px when border is < 2px (instead of 2px).
  Menu and window outline flickering problem also fixed.
                                                               (mackstann)

- TaskSwitcher now shows all windows instead of omitting current window.
  It initially selects the *second* window now, so behavior is the same,
  but now you can use __windowlist__ as a generic window list menu.
                                                               (mackstann)

- added windowMenuKeyPress() macro                             (mackstann)

- added macro for minimize button, enabled minimize button in default
  style                                                        (mackstann)

- fixed window snapping bug (#815578)                          (mackstann)

- taskswitcher behavioral fixes and adjustments                (mackstann)

- window procinfo working again          (jabba2k/PrinceOfChaos/mackstann)

- opaque argument for moveByTitlebar macro                       (hyriand)

- ViewportWrap{Up,Down,Left,Right} actions added, keyword arg added to
  viewportKnock and viewportSurf in userconfig, to toggle wrapping.
                   (mackstann (i think it was penguinx's idea originally))

- window size/position is now shown in the titlebar when opaquely moving/
  resizing windows.                                            (mackstann)

- Crosshair-style window outlines when moving window.  No formal interface
  to it yet, do screen().config.moveresize_crosshair = True to enable it
  in the meantime.                                             (mackstann)

- Buttons now retain their pressed appearance if you press them and then
  move the mouse away without letting go.  Basically, it acts like every
  other wm now.  Behavior not affected.                        (mackstann)

- Maximize now respects window size increments.                (mackstann)

- Windows with dock or toolbar type now can not normally be focused.  This
  fixes a problem where fspanel and gnome-panel (and others?) would steal
  the focus and cause inconsistencies in [un]minimizing windows.
                                                               (mackstann)

- Directional resize to bottom edge now works fine.            (dyfrgi)

- Maximized windows stay in their correct viewports across restarts now.
  (^^^ ok now it turns out that this wasn't fixed. ugh ^^^)
  Vert/horiz maximization is saved across restarts now.  Maximization
  button label updating bug fixed.                             (mackstann)

- Maximized windows now centered.                              (mackstann)

- Move to the new style backend with custom drawing        (PrinceOfChaos) 
  operations 

- Window contents now updated when moved                   (PrinceOfChaos)     
  (most noticeable on aterm with transparency)

- minimized windows menu, other things that make minimizing generally as
  functional as any other window manager.                      (mackstann)

- aterm -iconic works                                          (mackstann)

- focus-flicker management:
  - viewport switching now produces fewer artifacts with slow-drawing apps
    like mozilla.
  - DiscardEnterNotifies() and UserFocusFlicker{On,Off,}() can be used in
    scripts that implement their own focusing stuff, to prevent the
    various focusing routines from fighting with each other.

- decor is reduced when a window is maximized    (mackstann/PrinceOfChaos)

- Python output is logged now                                  (mackstann)

- resizing small windows is un-flakified, and an increment-related
  resizing bug (which caused increments to be ignored sometimes) squashed
                                                               (mackstann)

- window snapping won't allow a window to go offscreen         (mackstann)

- (limited) dockapp ordering is back                           (mackstann)

- new actions/window methods:
  - MoveWindowToCurrentViewport
  - RestrictMaxMovement
  - Is{Vertically,Horizontally,}OnScreen
  - Is{Vertically,Horizontally,}InWorkarea                     (mackstann)



Kahakai 0.5 -> 0.5.1
- Dockapp styles fixed in new style format                 (PrinceOfChaos)

- Window label no longer overwrites buttons for 
  non-Xft fonts                                            (PrinceOfChaos)

- Keyboard menu navigation now works (mostly)              (PrinceOfChaos)

- Xinerama: Windows maximize in their screen only,         (PrinceOfChaos)
  don't span several screens as before.

- Fixed always on top / at bottom and minimize                   (hyriand)

- Several shaping related fixes                                  (hyriand)

- Xinerama: Windows no longer placed between screens or    (PrinceOfChaos)
  in dead areas.

- Several window state related fixes (shade button now     (PrinceOfChaos)
  returns to "off" state on unshading, decoration settings
  remembered between restarts, unshading will now be 
  reflected in pagers/panels)

- "Reload menu" menu option removed, use auto-reloading instead  (hyriand)

- launch() function in autostart now only matches the end of
  the command name, which seems like it would be the best
  thing to match in most cases.                                (mackstann)

- Shaded state now restored after restarts                 (PrinceOfChaos)

- Reduction in binary size by about 15%                    (PrinceOfChaos)


Kahakai 0.4.1 -> 0.5
- Better handling of key name capitalization including     (PrinceOfChaos)     
  single letters                                                   (Faugn)

- The launch function in ~/autostart is now more strict,
  it doesn't check other users programs, and it should take
  into account the display.                                        (Faugn)

- "Last focused window on desktop" now works better              (hyriand)

- Better button handling (allows easy rearrangement by editing) in old
  style format                                             (PrinceOfChaos)

- Hidden (iconified) windows now displayed as "(window title)" in the
  window list.                                   (alpha-one/PrinceOfChaos)

- Better multiscreen support                                     (hyriand)

- Xft/Xrender/Xshape dependencies are now mandatory.       (PrinceOfChaos)
                                                                   (Faugn)

- Change of versions requirement (for users using cvs) :
  * aclocal/automake 1.6
  * autoheader/autoconf 2.54                                       (Faugn)

- Get rid of Esetroot dependency, now using hsetroot, thanks
  to hyriand.                                              (hyriand/Faugn)

- Partial-width titlebars (a la BeOS), use title: width = <pixels> or
  title: percent = <0-100 percent of frame width> or title: fitText=true
  to fit the titlebar to the text                          (PrinceOfChaos)

- Rounded corners now not applied to shaped windows without decor
  e.g. XMMS, panels/docks/splash screens                   (PrinceOfChaos)
  (like gnome-panel/kicker)

- Multiple fonts (like in CSS) supported, use font for normal font,
  with font2-10 for fallback fonts.                        (PrinceOfChaos)   

- Big improvement in startup time                (mackstann/PrinceOfChaos)
  (takes 40% less time on average) 

- mtime checking for and reload of menu file (and config/menu options)
                                                                 (hyriand)

- Window stacking lists moved from screen to desktop (and thus
  remembered correctly when switching desktops).                 (hyriand)

- Fixed segfault when a window is deleted before being fully constructed
                                                                 (hyriand)

- Fixed visual glitches with rounded corners on 
  title-less windows                                       (PrinceOfChaos)

- Fixed the opaque shaped window moving (gkrellm, xmms)          (hyriand)

- Per desktop stacking list root window properties (for pagers)  (hyriand)

- Desktop menus (both in root menu and window menus) are now 
  dynamically generated                              (Faugn/PrinceOfChaos)

- Moving a window resets its maximised state
  (like it's already the case when resizing it)                    (Faugn)

- Geometry bug fixed where windows would be offset by 2 pixels 
  or so from the edge when using -geometry -0-0 for example(PrinceOfChaos)

- Keys with no keysym assigned in X are now ignored, instead of
  matching every action                                    (PrinceOfChaos)

- Possibility to ignore modifiers (numlock / capslock)           (hyriand)

- NextTask/PreviousTask now respect SkipTaskList()         (PrinceOfChaos)

- Merged windows are no more.                                      (Faugn)

- Huge userconfig overhaul, including ditching config.py, and adding
  macros.py.  Notes for migration in doc/userconfig-migration-0.5.
                                                 (mackstann/PrinceOfChaos)

- Fixed visual glitch when moving border-less menus using outline 
                                                 (mackstann/PrinceOfChaos)

- Delays, like mouseRaise(delay=0.5) to raise if pointer stays in a 
  window for half of a second (Python support, C++ was mostly there)
                                                           (PrinceOfChaos)
        

Kahakai 0.4 -> 0.4.1
- Mouse raise (autoraise). Use mouseRaise() in globals()   (PrinceOfChaos)

- Settings menu works now (oops).                          (PrinceOfChaos)

Kahakai 0.3.1 -> 0.4
- Four directions resizing (SmartResize and
  ResizeNorthWest/NorthEast/SouthWest/SouthEast)           (PrinceOfChaos)

- Various menu related seg faults fixed (valaxer)

- Rounded corners support (only in the new style format) 
        (Credit: metacity, adapted by Eugene Pervago a.k.a. PrinceOfChaos)

- Changing the keymap no longer trash you key bindings, no need to restart
  Kahakai. The numlock/capslock bug was also fixed.                (Faugn)

- NextTask/PreviousTask now limited to current desktop 
  (as TaskSwitcher already is)                             (PrinceOfChaos)

- Last focused window on a desktop is now focused on switching to that 
  desktop                                                  (PrinceOfChaos)    

- Fixed the nested menu bug (more than 2 levels deep submenus).    (Faugn)

- Key names in the userconfig.py file are now case insensitives.   (Faugn)

- Fixed the click focus bug.                                       (Faugn)

- New menu function "unmerge", to unmerge a merged window.         (Faugn)

- Snapping on non-opaque moving                            (PrinceOfChaos)

- Resize snapping (opaque & non-opaque)                    (PrinceOfChaos)     

- Ctrl+Alt+<Number> keybindings for desktop switching are now dynamically
  generated to match the number of desktops present.
  (thanks to cristi for suggestion/example code, implemented by mackstann)

- Windows are now moveable by the handles, and handles/grips open a menu
  on right click.                                              (mackstann)

- New style/wallpaper                                          (mackstann)

Kahakai 0.3  -> 0.3.1
- Mozilla GDK bug fixes (thanks a lot valaxer for 10+ hours of work!)

Kahakai 0.2.2 -> 0.3
- Horizontal/vertical maximization (MaximizeVertically & MaximizeHorizontally).

- New style format (.kastyle) with much saner buttons specification and other
  improvements over *Box/Waimea format.

- Bug fixes.

Kahakai 0.2.1 -> 0.2.2

- Directional focusing

- "Ghost" empty dock fixed, was causing 3x3 black box in corner

- Windows now snap against the dockapps

Kahakai 0.2 -> 0.2.1

- 2px top of screen offset problem fixed

- Restart problem fixed

- Cleanup of window scripting API

- Default style tiny font fixed

- Window positioning is less buggy

Kahakai 0.1 -> 0.2

- New default theme

- Window/edge snapping

- Waimea action format is gone, replaced by scripted format.

- Experimental Ruby support (configure with --disable-python --enable-ruby)

- Autostart file support (if ~/.kahakai/autostart exists and is executable,
  Kahakai uses shell to execute it)

- Merged windows

- Transient windows (like dialogs) are centered over their parent window
  if it is visible.

Waimea-cvs (June 2003) -> Kahakai 0.1

- Better window placement: if no space is found using smart placement,
  window is centered on the mouse.

- Switching desktops while dragging a window will carry that window to
  the new desktop.

- Scripting support (Python for now, Perl/Ruby/others in the future)
  with action files almost completely replaced by scripted
  configuration files.

- .kahakai directory now created (if it doesn't exist already) and
  filled with sample configuration

- Unicode window titles support.

- TaskSwitcher (Alt-Tab by default) now shows only windows from
  current desktop.

- MoveWindowToViewport action

